from practicum import find_mcu_boards, McuBoard, PeriBoard
from time import sleep
import pygame

devs = find_mcu_boards()
pygame.mixer.init()

if len(devs) == 0:
    print("*** No practicum board found.")
    exit(1)

mcu = McuBoard(devs[0])
print("*** Practicum board found")
print("*** Manufacturer: %s" % \
        mcu.handle.getString(mcu.device.iManufacturer, 256))

peri = PeriBoard(mcu)

black_pressed = 0

red_sound = pygame.mixer.Sound("Cymbal_1-009.wav")
green_sound = pygame.mixer.Sound("Snare_1-015")
blue_sound = pygame.mixer.Sound("Kick_1-001.wav")
yellow_sound = pygame.mixer.Sound("Perc_1-005.wav")
red_sound.set_volume(1.0)
green_sound.set_volume(1.0)
blue_sound.set_volume(1.0)
yellow_sound.set_volume(1.0)

que=[]

sound_pins = {
        0: red_sound,
        1: green_sound,
        2: blue_sound,
        3: yellow_sound
        
    }

while True:
    red = peri.get_red()
    green = peri.get_green()
    blue = peri.get_blue()
    yellow = peri.get_yellow()
    black = peri.get_black()
    switch = peri.get_switch()
        
    if switch == 1:
        print("Reset")
        del que[:]
        black_pressed=0
    if red == 1:
        print("red")
        pygame.mixer.Channel(0).play(red_sound)
    if green == 1:
        print("green")
        pygame.mixer.Channel(1).play(green_sound)
    if blue == 1:
        print("blue")
        pygame.mixer.Channel(2).play(blue_sound)
    if yellow == 1:
        print("yellow")
        pygame.mixer.Channel(3).play(yellow_sound)
    if black == 1:
        print("black")
        if(len(que)!=0):
            print(que)
            for i in range(len(que)):        
                pygame.mixer.Channel(que[i]).play(sound_pins[que[i]])
                sleep(0.2) 
               
              # while pygame.mixer.get_busy() == True:
              #      continue
               
        elif(len(que)==0):
            if(black_pressed==0):
                black_pressed = 1
            elif(black_pressed==1):
                black_pressed = 0
   
    if black_pressed==1:
        if red == 1:
            red_sound.play()
            que.append(0)    
        if green == 1:
            green_sound.play()
            que.append(1)
        if blue == 1:
            blue_sound.play()
            que.append(2)
        if yellow == 1:
            yellow_sound.play()
            que.append(3)
    

    sleep(0.1)
   
